/*
 * Copyright (C) 2004 Nathan Lutchansky <lutchann@litech.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>
#include <time.h>

static int spookpid, minlevel;
static const char *month[] = {	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
				"Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };

int spook_log_init( int min )
{
	spookpid = getpid();
	minlevel = min;
	return 0;
}

void spook_log( int level, char *fmt, ... )
{
	va_list ap;
	char newfmt[512];
	struct tm tm;
	time_t t;

	va_start( ap, fmt );
	if( level >= minlevel )
	{
		time( &t );
		localtime_r( &t, &tm );
		sprintf( newfmt, "%s %2d %02d:%02d:%02d spook[%d]: %s\n",
				month[tm.tm_mon], tm.tm_mday,
				tm.tm_hour, tm.tm_min, tm.tm_sec,
				spookpid, fmt );
		vfprintf( stderr, newfmt, ap );
	}
	va_end( ap );
}
